function H=vert(a,x,t,k,bdegrees)
%This function solves the vertical scarp initial conditions problem for
%a = half scarp initial height
%x = distance along profile
%t = time
%k = diffusivity in distance^2/time
%bdegrees is far field slope in degrees
%b = far field slope in radians
%from Hanks, T. C., R. C. Bucknam, K. R. Lajoie and R. E. Wallace,
%Modification of wave-cut and fault-controlled landforms,
%\emph{Journal of Geophysical Research}, \emph{89}, 5771-5790,
%1984.

b=bdegrees*pi/180;

H=a.*erf(x./(2.*sqrt(k.*t)))+b.*x;
